/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

//To display all the Processes running on server

import javax.microedition.lcdui.* ;
import javax.microedition.midlet.* ;
import javax.microedition.io.* ;
import java.io.* ;
import java.lang.String.* ;
import java.util.* ;

/**
 *
 * @author Aks
 */

class ProcessList extends List implements CommandListener {
    
    Command back , kill, no, memUsage ;
    Display display ;
    Menus menu ;
    Processes processes ;
    int index;
    Form form ;
    String processList ;
    int noOfProcess;
    
    String[] pList ;
    String temp ;
    public ProcessList(Display d, String plist, Form frm) {
        super("Processes", Choice.IMPLICIT ) ;
        System.out.println("ProcessList") ;
        form = frm ;
        this.display = d ;
        processList = plist ;
        
        processList = processList.substring(2) ;
        pList = split(processList, "$$") ;
        System.out.println("Length:" + processList.length()) ;
        
        System.out.println("pList:" + pList[0]) ;
        int ind ;
        String processName ;
        for (int i=2 ; i<pList.length ; i++) {
            System.out.println(pList[i]) ;
            ind = pList[i].indexOf("*") ;
            processName = pList[i].substring(0, ind) ;
            this.append(processName,loadImage("/Process.png")) ;
        }
        noOfProcess = pList.length ;
        
        back = new Command("Back", Command.BACK, 0) ;
        kill = new Command("Kill", Command.SCREEN, 0) ;
        memUsage = new Command("Memory Usage", Command.SCREEN, 0) ;
        no = new Command("N(Processes)", Command.SCREEN, 0) ;
        
        this.addCommand(back) ;
        this.addCommand(kill) ;
        this.addCommand(memUsage) ;
        this.addCommand(no) ;
        
        this.setCommandListener(this) ;
        display.setCurrent(this) ;
        
    }
    
    private Image loadImage(String name) {
        Image image = null;
        try {
            image = Image.createImage(name);
        }
        catch (IOException ioe) {
            System.out.println(ioe);
        }

        return image;
    }
    
    
    private String[] split(String original, String separator) {
        Vector nodes = new Vector();
        
        int ind = original.indexOf(separator);
        
        while(index>=0) {
            nodes.addElement( original.substring(0, ind) );
            original = original.substring(ind+separator.length());
            ind = original.indexOf(separator);
            if(ind == -1) {
                break ;
            }
        }
        
        // Get the last node
        nodes.addElement( original );
 
        // Create splitted string array
        String[] result = new String[ nodes.size() ];
        if( nodes.size()>0 ) {
            for(int loop=0; loop<nodes.size(); loop++)
                result[loop] = (String)nodes.elementAt(loop);
        }
        return result;
    }

    public void commandAction(Command c, Displayable d) {
        index = this.getSelectedIndex();
        System.out.println("index  "+index);
        
        if( c == back ) {
            processes = new Processes(display, form) ;
        }
        else if( c == no ) {
            Alert alertPID = new Alert("Number of Processes", "Total number of process currently running:  " + noOfProcess, null, AlertType.INFO) ;
            alertPID.setTimeout(5000) ;
            
            display.setCurrent(alertPID) ;
        }
        else if(c == memUsage ) {
            
            int ind ;
            ind = pList[index+2].indexOf("*") ;
            System.out.println("ind:" + ind) ;
            String memStat = pList[index+2].substring(ind+1) ;
            Alert alertMemStatus = new Alert("Memory Usage", "Memory Usage of " + this.getString(index) + " is : " + memStat + " .", null, AlertType.INFO) ;
            alertMemStatus.setTimeout(Alert.FOREVER) ;
            
            display.setCurrent(alertMemStatus) ;
        }
        else if(c == kill) {
            noOfProcess-- ;
            System.out.println("name :" + this.getString(index)) ;
            String proc = this.getString(index) ;
            proc = proc.replace('+', '|') ;
            System.out.println(proc) ;
            SockConnection sock = new SockConnection(display, "KL$" + proc, form) ;
        }
                
    }
    
}